_ALLREPOS/blog-on-rails/config/routes.rb
Blog::Application.routes.draw do
  

  get "sessions/destroy"
  get "sessions/new"
  get "home/index"
  get "admin/index"
  get "contact/index"
  get "about/index"  
  get "portfolio/index"
  
  resources :contacts #, only: [:new, :create]
  resources :sessions
  resources :users
  resources :tags       #get "tags/show"
  resources :projects
  resources :companies
  resources :posts do
    resources :comments
  end
  
  match 'register', :to => 'users#new'
  match 'login', :to => 'sessions#new'
  match 'logout', :to => 'sessions#destroy'
  match 'contactme', :to => 'contacts#new'
  match 'about', :to => 'about#index'
  match 'portfolio', :to => 'portfolio#index'
  match 'blog', :to => 'posts#index'
  match 'sitemap', to: 'sitemap#index'
  
  match 'rss', to: 'sitemap#rss'
  match 'feed', to: 'sitemap#rss'
  match 'feed.rss', to: 'sitemap#rss'
 

  root :to => 'home#index'

end

_ALLREPOS/blog-on-rails/app/models/comment.rb
class Comment < ActiveRecord::Base
  validates :commenter, presence: true
  validates :body, presence: true
  
  belongs_to :post
end

_ALLREPOS/blog-on-rails/app/models/company.rb
class Company < ActiveRecord::Base
  has_many :projects
end

_ALLREPOS/blog-on-rails/app/models/contact.rb
class Contact < ActiveRecord::Base
end

_ALLREPOS/blog-on-rails/app/models/post.rb
class Post < ActiveRecord::Base
  extend FriendlyId
  before_validation :check_tags
  
  friendly_id :title, use: [:slugged, :history]
  
  #validates :name, :presence => true
  validates :title, :presence => true, :length => { :minimum => 2}

  belongs_to :user  
  has_many :comments, dependent: :destroy, :autosave => true
  has_and_belongs_to_many :tags, :autosave => true
  
  accepts_nested_attributes_for :tags, allow_destroy: :true, 
    reject_if: proc{ |attrs| attrs.all?{|k,v| v.blank? } }
	
	
  private
	# Use an existing tag if it already exists.
	def check_tags
		tags.map! do |tag|
			existing_tag = Tag.find_by_name(tag.name)
			(existing_tag)? existing_tag : tag
		end
	end
end

=begin
	In a create operation under Rails, there are six callbacks before the database operation, and two after. In order, these are:

	before_validation
	before_validation_on_create
	after_validation
	after_validation_on_create
	before_save
	before_create
	DATABASE INSERT
	after_create
	after_save
=end

_ALLREPOS/blog-on-rails/app/models/project.rb
class Project < ActiveRecord::Base
  belongs_to :company
end

_ALLREPOS/blog-on-rails/app/models/tag.rb
class Tag < ActiveRecord::Base
  extend FriendlyId
  friendly_id :name, use: :slugged
  validates :name, presence: true, :uniqueness => {:case_sensitive => false }
  has_and_belongs_to_many :posts
end

_ALLREPOS/blog-on-rails/app/models/user.rb
require 'digest'

class User < ActiveRecord::Base
  attr_accessor :password
  attr_accessible :name, :email, :password, :password_confirmation
  
  has_many :posts
  
  validates :name,  :presence   => true,
                    :length     => { :maximum => 80 }
  
  validates :password,  :presence     => true,
                        :confirmation => true,
                        :length       => { :within => 4..40 }

  email_regex = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  validates :email, :presence => true,
                    :format => {:with => email_regex},
                    :uniqueness => {:case_sensitive => false }

  before_save :encrypt_password

  def has_password? (submitted_password)
    encrypted_password == encrypt(submitted_password)
  end

  def self.authenticate (email, submitted_password)
    user = find_by_email(email)
    return nil if user.nil?
    return user if user.has_password?(submitted_password)    
  end
  
  def self.authenticate_with_salt(id, cookie_salt)
    user = find_by_id(id)
    (user && user.salt == cookie_salt) ? user : nil
  end
  
  private
    def encrypt_password
      self.salt = make_salt if new_record?
      self.encrypted_password = encrypt(password)
    end
    
    def encrypt(string)
      secure_hash("#{salt}--#{string}")
    end
    
    def make_salt
      secure_hash("#{Time.now.utc}--#{password}")
    end
    
    def secure_hash(string)
      Digest::SHA2.hexdigest(string)
    end
    
end

_ALLREPOS/blog-on-rails/app/helpers/about_helper.rb
module AboutHelper
end

_ALLREPOS/blog-on-rails/app/helpers/admin_helper.rb
module AdminHelper
end

_ALLREPOS/blog-on-rails/app/helpers/comments_helper.rb
module CommentsHelper
end

_ALLREPOS/blog-on-rails/app/helpers/companies_helper.rb
module CompaniesHelper
end

_ALLREPOS/blog-on-rails/app/helpers/contacts_helper.rb
module ContactsHelper
end

_ALLREPOS/blog-on-rails/app/helpers/home_helper.rb
module HomeHelper
end

_ALLREPOS/blog-on-rails/app/helpers/portfolio_helper.rb
module PortfolioHelper
end

_ALLREPOS/blog-on-rails/app/helpers/posts_helper.rb
module PostsHelper
  def post_tags(post)
    post.tags.map { |t| link_to(t.name, t) }.join(", ") if not post.tags.nil?
  end
end

_ALLREPOS/blog-on-rails/app/helpers/projects_helper.rb
module ProjectsHelper
end

_ALLREPOS/blog-on-rails/app/helpers/sessions_helper.rb
module SessionsHelper

  def sign_in(user)
    cookies.permanent.signed[:remember_token] = [user.id, user.salt]
    current_user = user
  end  

  def signed_in?
    !current_user.nil?
  end
  
  def sign_out
    cookies.delete(:remember_token)
    current_user = nil
  end
  
  def current_user
    @current_user ||= user_from_remember_token 
  end
  
  private
    def user_from_remember_token
      User.authenticate_with_salt(*remember_token)
    end

    def remember_token
      cookies.signed[:remember_token] || [nil, nil]
    end
  
end

_ALLREPOS/blog-on-rails/app/helpers/sitemap_helper.rb
module SitemapHelper
end

_ALLREPOS/blog-on-rails/app/helpers/tags_helper.rb
module TagsHelper
end

_ALLREPOS/blog-on-rails/app/helpers/users_helper.rb
module UsersHelper
  def gravatar_for (user, options = {:size => 200})
    gravatar_image_tag(user.email.downcase,
                        :alt    => user.name,
                        :class  => 'gravatar',
                        :gravatar => options 
    )
  end
end

_ALLREPOS/blog-on-rails/app/views/layouts/_flash_errors.html.haml
- if flash[:error] and flash[:error].any?
	#error_explanation
		%h2= "#{pluralize(flash[:error].count, "error")} prohibited this data from being saved:"
		%ul
			- flash[:error].full_messages.each do |msg|
				%li= msg

_ALLREPOS/blog-on-rails/app/views/layouts/application.html.haml
!!! html
%html
	%head
		-# http://gradients.glrzad.com/ TODO use it
		%meta(charset="utf-8")
		%meta{name: "description", content: "#{content_for?(:meta_description) ? yield(:meta_description) : "Adrian Mejia's website and articles related to his work experiences in software engineering, web development, technologies, web frameworks and so on."}"}
		%meta{name: "keywords", content: "#{content_for?(:meta_keywords) ? yield(:meta_keywords) : "software engineering, ruby on rails, ruby, java, blog, technology, internet, person"}"}
		%title= content_for?(:title) ? yield(:title) : 'Adrian Mejia - Blog'
		/ Le HTML5 shim, for IE6-8 support of HTML elements
		/[if lt IE 9]
			= javascript_include_tag "http://html5shim.googlecode.com/svn/trunk/html5.js"
		= stylesheet_link_tag "application", :media => "all"
		=# stylesheet_link_tag "twitter/bootstrap"
		=# stylesheet_link_tag "twitter/bootstrap-responsive"
		= stylesheet_link_tag "bootstrap.min"
		= stylesheet_link_tag "prettify"
		= csrf_meta_tags
		=raw '<meta name="viewport" content="width=device-width, initial-scale=1.0">'
		= auto_discovery_link_tag(:rss, "/rss.xml", {:title => "RSS Feed"})
		= content_for?(:stylesheets) ? yield(:stylesheets) : ""
		
	%body
		%div.container
			%header
				%nav
					%ul{:class => "nav nav-pills"}
						%li{:class => active?(@title, "Home") }= link_to "Home", root_path
						%li{:class => active?(@title, "Portfolio") }= link_to "Portfolio", portfolio_path
						%li{:class => active?(yield(:title), "Blog") }= link_to "Blog", blog_path
						%li{:class => active?(@title, "About") }= link_to "About", about_path
						%li{:class => active?(@title, "Contact") }= link_to "Contact", contactme_path
						- if signed_in?
							%li{:class => active?(@title, "Admin") }= link_to "Admin", admin_index_path
						- else
							%li{:class => active?(@title, "Login") }= link_to "Login", login_path

			%section.container-fluid#main-content
				%div.row-fluid
					%div.span9
						-# <!--Body content-->
						= yield
					%div.span3
						-# <!--Sidebar content-->
						%nav
							%ul{:class=>"nav nav-tabs nav-stacked"}
								- if signed_in?
									%li= link_to "Profile", current_user
									%li= link_to "Create a Post", new_post_path
									%li= link_to "View messages", contacts_path
									%li -
									%li= link_to "Logout", logout_path

			
			%footer
				%hr
				= "Copyright © 2011-#{Time.now.year} by "
				= link_to "Adrian Mejia", "http://adrianmejia.com"
				· All Rights Reserved.
		
			
			- if Rails.env.development?
				%hr
				= debug(params) 			
				%br
				= debug(flash)
				%br
				=# debug(request.host)
				=# debug(request.domain)
				= debug(request.url)
				= debug(request.remote_ip)
				
		=# javascript_include_tag "twitter/bootstrap"
		= javascript_include_tag "application"
		= javascript_include_tag "prettify"
		= javascript_include_tag "bootstrap.min"
		= render 'layouts/googleanalytics'
		= content_for?(:javascripts) ? yield(:javascripts) : ""
		